/*
	File:		HackDirectory.r

	Contains:	xxx put contents here xxx

	Written by:	John Evans

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<3+>	 6/27/93	sf		Sync to B6
		 <3>	  4/7/93	sf		API Change
		<1+>	 3/30/93	sf		sync to new header
		 <1>	 3/29/93	jse		first checked in

	To Do:
*/



#define SystemSevenOrLater 1

#include "Types.r"
#include "OCETemplates.h"
#include "OCE.r"
#include "SAMTemplates.h"
#include "TemplateUtils.h"
#include "TemplateIDs.h"
#include "TemplateHeaderDefs.h"

//--------------------------------------------------------------------------------------------------

#define kHackAspect		1000
#define kHackInfoPage	1250

#define kSignature				'blch'
#define kServiceRecordType		kDirectoryRecTypeBody "blch"
#define kAspectName				"Hack_Aspect"
#define kInfoPageName			"Hack_Info_Page"

//--------------------------------------------------------------------------------------------------

resource 'deta' (kHackAspect, purgeable)
{
	0, dropCheckConflicts, isMainAspect
};

resource 'rstr' (kHackAspect + kDETTemplateName, purgeable)
{
	kAspectName
};

resource 'rstr' (kHackAspect + kDETRecordType, purgeable)
{
	kServiceRecordType
};

resource 'rstr' (kHackAspect + kSAMAspectKind, purgeable)
{
	"Catalog"
};

resource 'rstr' (kHackAspect + kDETAspectKind, purgeable)
{
	"Catalog"
};

resource 'rstr' (kHackAspect + kDETAspectName, purgeable) {
	"untitled Bletch catalog"
};

resource 'rstr' (kHackAspect + kSAMAspectUserName, purgeable) {
	"Bletch User"
};


resource 'sami' (kHackAspect + kSAMAspectSlotCreationInfo, purgeable)
{
	2,
	kSignature,
	notMSAM,
	servesDSAM,
	"Bletch Catalog",
	"untitled Bletch catalog"
};

//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------

resource 'detw' (kHackAspect + kDETAspectInfoPageCustomWindow, purgeable)
	{
	{-1, -1, kWindowHeight, kWindowWidth},
	includePopup
	};

//--------------------------------------------------------------------------------------------------
// Info-page:	(for View by Field)
//--------------------------------------------------------------------------------------------------

resource 'deti' (kHackInfoPage, purgeable)
{
	kDefaultSortIndex,
	kZeroRect,
	noSelectFirstText,
	{
		kDETNoProperty, 	kDETNoProperty, 	kHackInfoPage;
	},
	{
	}
};

resource 'rstr' (kHackInfoPage + kDETTemplateName, purgeable) {
	kInfoPageName
};

resource 'rstr' (kHackInfoPage + kDETRecordType, purgeable) {
	kServiceRecordType
};

resource 'rstr' (kHackInfoPage + kDETInfoPageName, purgeable) {
	"Bletch Directory"
};

resource 'rstr' (kHackInfoPage + kDETInfoPageMainViewAspect, purgeable) {
	kAspectName
};

resource 'detv' (kHackInfoPage, "subpageview", purgeable)
	{
	{
	kDoubleLineRect, kDETNoFlags, kDETNoProperty,
	Box { kDETBoxIsGrayed };

	kDETSubpageIconRect, kDETNoFlags, kDETAspectMainBitmap,
	Bitmap { kDETLargeIcon };
	};
	};

//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------

resource 'icl8' (kHackAspect + kDETAspectMainBitmap, "NBPUser", purgeable) {
	$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 FF00 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 FFFF 0000 0000 FFFF FFFF FF00 0000 0000 FFFF FFFF FFFF 0000 0000 0000 0000"
	$"00FF FAF8 FFFF FFFF 0000 F5F5 F7FF FF00 FFFF 0000 F5F5 F5F6 FFFF FF00 0000 0000"
	$"FFFA F8F8 2BF6 F5F5 0000 F5F5 F7F7 F8FF F5F5 0000 F5F5 F5F6 F6F6 2BFF FFFF FFFF"
	$"FFFA F8F8 2BF6 F5F5 0000 F5F5 F7F8 F8F9 F5F5 0000 F5F5 F5F6 F62B 2B2B 2BF8 FAFF"
	$"FFFA F8F8 2BF6 F5F5 0000 F5F5 F7F7 F8FA F5F5 0000 F5F5 F5F6 F6F6 2BF7 2BF8 FAFF"
	$"FFFA F8F8 2BF6 F5F5 0000 F5F5 F7F8 F8F9 F5F5 0000 F5F5 F5F6 F62B 2BF7 2BF8 FAFF"
	$"FFFA F8F8 2BF6 F5F5 0000 F5F5 F7F7 F8FA F5F5 0000 F5F5 F5F6 F6F6 2BF7 2BF8 FAFF"
	$"FFFA F82B 2BF5 F5F5 0000 F5F5 F7F8 F8F9 F5F5 0000 F5F5 F5F6 E32B 2BF7 2BF8 FAFF"
	$"FFFA F82B 2BF5 F5F5 0000 F5F5 F7F7 F8FA F5F5 0000 F5F5 F5E3 E3F6 2BF7 2BF8 FAFF"
	$"FFFA F82B 2BF5 F5F5 0000 F5F5 F7F8 F8F9 F5F5 0000 F5F5 F5E3 F62B 2BF7 2BF8 FAFF"
	$"FFFA F82B 2BF5 F5F5 0000 F5F5 F7F7 F8FA F5F5 0000 E3E3 F5F6 E3E3 2BF7 2BF8 FAFF"
	$"FFFA F82B 2BF5 F5F5 0000 F5F5 F7F8 F8F9 F5F5 00E3 E3E3 E3E3 E3E3 E3F7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 0000 F5F5 F7F7 F8FA F5F5 0505 0505 0505 0505 2BF7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 0000 F5F5 F7F8 F8F9 F5F5 1717 1717 1717 1717 2BF7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 0000 F5F5 F7F7 F8FA F5F5 D8D8 D8D8 D8D8 D8D8 D8F7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 0000 F5F5 F7F8 F8F9 F5F5 2020 2020 2020 2020 20F7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 0000 F5F5 F7F7 F8FA F5F5 00EC ECEC ECEC ECEC 2BF7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 0000 F5F5 F7F8 F8F9 F5F5 0000 ECEC F5EC EC2B 2BF7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 0000 F5F5 F7F7 F8FA F5F5 0000 F5F5 F5F6 F6F6 2BF7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 0000 F5F5 F7F8 F8F9 F5F5 0000 F5F5 F5F6 F62B 2BF7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 0000 F5F5 F7F7 F8FA F5F5 0000 F5F5 F5F6 F6F6 2BF7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 00F5 F5F5 F7F8 F8F9 F5F5 00F5 F5F5 F5F6 F62B 2BF7 2BF8 FAFF"
	$"FFFA F82B F6F5 F5F5 F6F6 F6F6 F7F7 F8FA F5F5 00F6 F6F6 F6F6 F6F6 2B2B 2BF8 FAFF"
	$"FFFA F8F8 F8F8 F8F8 F9F9 F9FA FAF6 F6FC F6F6 FAFA F9F9 F9F8 F8F8 F8F8 F8F8 FAFF"
	$"FFFA FAFA FAFA FAFA FAFA FAFA FAF9 FFFF FFF9 FAFA FAFA FAFA FAFA FAFA FAFA FAFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FC00 FCFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'ICN#' (kHackAspect + kDETAspectMainBitmap, "NBPUser", purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 2000 0000 30F8 3F00 4F06 C0E0"
		$"A001 001F C000 0005 A001 0003 C000 0005 A001 0003 C000 0085 A001 0183 C000 0105"
		$"A001 0CC3 C000 1FE5 A001 3FC3 C000 3FC5 A001 3FE3 C000 3FE5 A001 1FC3 C000 0D85"
		$"A001 0003 C000 0005 A001 0003 C000 0005 A0A9 2A03 D557 D555 AAAB AAAB FFFE FFFF",
		/* [2] */
		$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 2000 0000 30F8 3F00 7FFE FFE0"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFE FFFF"
	}
};

resource 'icl4' (kHackAspect + kDETAspectMainBitmap, "NBPUser", purgeable) {
	$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000 00F0 0000 0000 0000 0000 0000 0000 0000"
	$"00FF 0000 FFFF F000 00FF FFFF 0000 0000 0FDC FFFF 0C0C CFF0 FF0C 0C0C FFF0 0000"
	$"FDCC CCC0 00C0 CCCF C000 C0CC CCCF FFFF FDCC CC0C 0C0C CCDD 0C0C 0C0C CCCC CCDF"
	$"FDCC CCC0 00C0 CDCD C000 C0CC CCCC CDDF FDCC CC0C 0C0C CCDD 0C0C 0C0C CCCC CCDF"
	$"FDCC CCC0 00C0 CDCD C000 C0CC CCCC CDDF FDCC CC0C 0C0C CCDD 0C0C 0C0C 8CCC CCDF"
	$"FDCC C0C0 00C0 CDCD C000 C0C8 8CCC CDDF FDCC CC0C 0C0C CCDD 0C0C 0C08 CCCC CCDF"
	$"FDCC C0C0 00C0 CDCD C000 88CC 88CC CDDF FDCC CC0C 0C0C CCDD 0C08 8888 888C CCDF"
	$"FDCC C0C0 00C0 CDCD C011 1111 11CC CDDF FDCC CC0C 0C0C CCDD 0C22 2222 22CC CCDF"
	$"FDCC C0C0 00C0 CDCD C033 3333 333C CDDF FDCC CC0C 0C0C CCDD 0C44 4444 444C CCDF"
	$"FDCC C0C0 00C0 CDCD C006 6666 66CC CDDF FDCC CC0C 0C0C CCDD 0C0C 6606 6CCC CCDF"
	$"FDCC C0C0 00C0 CDCD C000 C0CC CCCC CDDF FDCC CC0C 0C0C CCDD 0C0C 0C0C CCCC CCDF"
	$"FDCC C0C0 00C0 CDCD C000 C0CC CCCC CDDF FDCC CC0C 0C0C CCDD 0C0C 0C0C CCCC CCDF"
	$"FDCC C0C0 CCCC CDCD C0CC CCCC CCCC CDDF FDCC CCCC DDDD DCCE CCDD DDDC CCCC CCDF"
	$"FDDD DDDD DDDD DDFF FDDD DDDD DDDD DDDF FFFF FFFF FFFF FFE0 EFFF FFFF FFFF FFFF"
};

