{***********************************************************

Created: Sunday, June 6, 1993 at 3:00PM
 OCEStandardDirectory.p
 Pascal Interface to the Macintosh Libraries

  Copyright Apple Computer, Inc. 1990-1993
  All rights reserved

***********************************************************}


{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes:= 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT OCEStandardDirectory;
	INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingOCEStandardDirectory}
{$SETC UsingOCEStandardDirectory:= 1}

{$I+}
{$SETC OCEStandardDirectoryIncludes:= UsingIncludes}
{$SETC UsingIncludes:= 1}


{$IFC UNDEFINED UsingOCE}
{$I OCE.p}
{$ENDC}

{$IFC UNDEFINED UsingOCEAuthDir}
{$I OCEAuthDir.p}
{$ENDC}

{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}

{$IFC UNDEFINED UsingWindows}
{$I $$Shell(PInterfaces)Windows.p}
{$ENDC}

{$IFC UNDEFINED UsingIcons}
{$I $$Shell(PInterfaces)Icons.p}
{$ENDC}

{$SETC UsingIncludes:= OCEStandardDirectoryIncludes}



{ CollabPack Trap Selectors }

CONST
kSDPNewPanel					= 100;
kSDPGetNewPanel					= 101;
kSDPDisposePanel				= 102;
kSDPHidePanel					= 103;
kSDPShowPanel					= 104;
kSDPEnablePanel					= 105;
kSDPUpdatePanel					= 106;
kSDPMovePanel					= 107;
kSDPSizePanel					= 108;
kSDPOpenSelectedItem			= 109;
kSDPGetPanelSelectionState		= 110;
kSDPGetPanelSelection			= 111;
kSDPSetPath						= 112;
kSDPPanelEvent					= 113;
kSDPGetPanelSelectionSize		= 114;
kSDPSetIdentity					= 115;
kSDPSelectString				= 116;
kSDPGetPathLength				= 117;
kSDPGetPath						= 118;
kSDPSetFocus					= 119;
kSDPSetPanelBalloonHelp			= 120;
kSDPInstallPanelBusyProc		= 121;

kSDPPromptForID					= 904;

kSDPNewFindPanel				= 2300;
kSDPDisposeFindPanel			= 2301;
kSDPStartFind					= 2302;
kSDPStopFind					= 2303;
kSDPFindPanelEvent				= 2304;
kSDPDrawFindPanel				= 2305;
kSDPShowFindPanel				= 2306;
kSDPHideFindPanel				= 2307;
kSDPMoveFindPanel				= 2308;
kSDPEnableFindPanel				= 2309;
kSDPSetFindPanelFocus			= 2310;
kSDPGetFindPanelState			= 2311;
kSDPGetFindPanelSelectionSize	= 2312;
kSDPGetFindPanelSelection		= 2313;
kSDPSetFindPanelBalloonHelp		= 2314;
kSDPSetFindIdentity				= 2315;
kSDPInstallFindPanelBusyProc	= 2316;

kSDPGetIconByType				= 1024;
kSDPGetDSSpecIcon				= 1025;
kSDPGetCategories				= 1026;
kSDPGetCategoryTypes			= 1027;

kSDPResolveAliasFile			= 3700;
kSDPResolveAliasDSSpec			= 3701;

kSDPRepairPersonalDirectory		= 6700;



{ Collaboration Package Gestalts. }

gestaltSDPStandardDirectoryVersion	= 'sdvr';
gestaltSDPFindVersion				= 'dfnd';
gestaltSDPPromptVersion				= 'prpv';



{$IFC UNDEFINED svLarge1Bit}
{  Selector mask values  }
{ This is temporary. It will eventually appear in Icons.h }

TYPE
IconSelectorValue = LONGINT;


CONST
svLarge1Bit			= $00000001;
svLarge4Bit			= $00000002;
svLarge8Bit			= $00000004;
svSmall1Bit			= $00000100;
svSmall4Bit			= $00000200;
svSmall8Bit			= $00000400;
svMini1Bit			= $00010000;
svMini4Bit			= $00020000;
svMini8Bit			= $00040000;
svAllLargeData		= $000000ff;
svAllSmallData		= $0000ff00;
svAllMiniData		= $00ff0000;
svAll1BitData		= (svLarge1Bit + svSmall1Bit + svMini1Bit);
svAll4BitData		= (svLarge4Bit + svSmall4Bit + svMini4Bit);
svAll8BitData		= (svLarge8Bit + svSmall8Bit + svMini8Bit);
svAllAvailableData	= $ffffffff;
{$ENDC}


{ generic icon suites }
CONST
genericDirectoryIconResource			= -16721;	{ icl8, icl4, ICN#, ics#, ics4, ics8, sicn  }
genericLockedDirectoryIconResource		= -16716;	{ icl8, icl4, ICN#, ics#, ics4, ics8, sicn  }
genericRecordIconResource				= -16722;	{ icl8, icl4, ICN#, ics#, ics4, ics8, sicn  }
genericAttributeIconResource			= -16723;	{ icl8, icl4, ICN#, ics#, ics4, ics8, sicn  }
genericTemplateIconResource				= -16746;	{ icl8, icl4, ICN#, ics#, ics4, ics8 }

{ standard icon suites }

directoryFolderIconResource				= -16720;	{ icl8, icl4, ICN#, ics#, ics4, ics8, sicn  }
lockedDirectoryFolderIconResource		= -16719;	{ icl8, icl4, ICN#, ics#, ics4, ics8, sicn  }
personalDirectoryIconResource			= -16718;	{ icl8, icl4, ICN#, ics#, ics4, ics8, sicn  }
directoriesIconResource					= -16717;	{ icl8, icl4, ICN#, ics#, ics4, ics8, sicn  }
preferredPersonalDirectoryIconResource	= -16724;	{ icl8, icl4, ICN#, ics#, ics4, ics8, sicn  }

{ icon IDs for spinning arrows }
kFirstSpinnerIcon						= -16745;
kLastSpinnerIcon						= -16738;


{ resource types }
kSDPPanelResourceType					= 'panl';
kSDPFindPanelResourceType				= 'find';

{ Standard FindPanel resource }
kStandardFindLayout						= -16700;


{ Prompt For Identity structures }

kSDPGuestBit = 0;
kSDPSpecificIdentityBit = 1;
kSDPLocalIdentityBit = 2;

{ Values of SDPIdentityKind }
kSDPGuestMask 				= $0001;  {1<<kSDPGuestBit}
kSDPSpecificIdentityMask 	= $0002;  {1<<kSDPSpecificIdentityBit}
kSDPLocalIdentityMask 		= $0004;  {1<<kSDPLocalIdentityBit}


TYPE
SDPIdentityKind = INTEGER;

CONST
kSDPSuggestionOnly = 0;
kSDPRestrictToDirectory = 1;
kSDPRestrictToRecord = 2;

TYPE
SDPLoginFilterKind = INTEGER;




{ Panel Structures }

{
While the panel is in operation, four selection states may exist.
	1) kSDPNothingSelected means nothing is selected.
	2) kContainSelected means a volume, folder, directory, dnode, or PAB is selected.
	3) kSDPLockedContainerSelected means one of the above, but no access privledges.
	4) kSDPRecordSelected means that a record is currently selected.
}

CONST
{ Values of SDPSelectionState }
kSDPNothingSelected = 0;
kSDPLockedContainerSelected = 1;
kSDPContainerSelected = 2;
kSDPRecordSelected = 3;
kSDPRecordAliasSelected = 4;
kSDPContainerAliasSelected = 5;

TYPE
SDPSelectionState = INTEGER;




{
This type informs the caller of the action the user took, either as the result
of an event (as returned by SDPPanelEvent) or when SDPOpenSelectedItem is called.

kSDPProcessed means that the event (or call to SDPOpenSelectedItem) resulted in no
state change.

kSDPSelectedAnItem indicates that the user wants to select the currently-hilited
record. This is returned, for example, when a user double-clicks on a record.

kSDPChangedSelection implies that the user clicked on a new item (which may mean
that no item is selected).
}

CONST
{ Values of SDPPanelState }
kSDPProcessed = 0;
kSDPSelectedAnItem = 1;
kSDPChangedSelection = 2;

TYPE
SDPPanelState = INTEGER;


{
Your application may read any of the fields in a SDPPanelRecord, but it should
use the appropriate routines to make changes to the records with the exception
of the refCon field which your application may read or write at will.  Private
information follows the SDPPanelRecord, so the handle must not be re-sized.
}

SDPPanelRecord = RECORD
	bounds: Rect;
	visible: BOOLEAN;
	enabled: BOOLEAN;
	focused: BOOLEAN;
	{padByte: Byte;}
	identity: AuthIdentity;
	refCon: LONGINT;
	listRect: Rect;
	popupRect: Rect;
	numberOfRows: INTEGER;
	rowHeight: INTEGER;
	pabMode: BOOLEAN;
	END;


SDPPanelPtr = ^SDPPanelRecord;
SDPPanelHandle = ^SDPPanelPtr;

PanelBusyProc = ProcPtr;
	{ PROCEDURE PanelBusyProc(Panel: SDPPanelHandle; busy: BOOLEAN); }





{ Find Panel Structures }
CONST
kSDPItemIsSelectedBit = 0;
kSDPFindTextExistsBit = 1;
{ Values of SDPFindPanelState }
kSDPItemIsSelectedMask = $0001;  {1<<kSDPItemIsSelectedBit}
kSDPFindTextExistsMask = $0002;  {1<<kSDPFindTextExistsBit}


TYPE
SDPFindPanelState = INTEGER;


{ Values of SDPFindPanelFocus }
CONST
kSDPFindPanelNoFocus = 0;
kSDPFindPanelListHasFocus = 1;
kSDPFindPanelTextHasFocus = 2;


TYPE
SDPFindPanelFocus = INTEGER;


SDPFindPanelRecord = RECORD
	upperLeft: Point;
	visible: BOOLEAN;
	enabled: BOOLEAN;
	nowFinding: BOOLEAN;
	{padByte: Byte;}
	currentFocus: SDPFindPanelFocus;
	identity: AuthIdentity;
	simultaneousSearchCount: INTEGER;
	refCon: LONGINT;
	END;


SDPFindPanelPtr = ^SDPFindPanelRecord;
SDPFindPanelHandle = ^SDPFindPanelPtr;


CONST
{ Values of SDPFindPanelResult }
kSDPSelectedAFindItem = 0;
kSDPFindSelectionChanged = 1;
kSDPFindCompleted = 2;
kSDPTextStateChanged = 3;
kSDPFocusChanged = 4;
kSDPSelectionAndFocusChanged = 5;
kSDPMenuChanged = 6;
kSDPSelectionAndMenuChanged = 7;
kSDPProcessedFind = 8;

TYPE
SDPFindPanelResult = INTEGER;


PackedRStringListHandle = ^PackedPathNamePtr;

PackedDSSpecHandle = ^PackedDSSpecPtr;

FindPanelBusyProc = ProcPtr;
	{PROCEDURE FindPanelBusyProc(findPanel: SDPFindPanelHandle; busy: BOOLEAN); }


{ Prompt For Identity Routines }


FUNCTION SDPPromptForID(VAR id: AuthIdentity;
						guestPrompt: StringPtr;
						specificIDPrompt: StringPtr;
						localIDPrompt: StringPtr;
						recordType: RStringPtr;
						permittedKinds: SDPIdentityKind;
						VAR selectedKind: SDPIdentityKind;
						loginFilter: RecordIDPtr;
						filterKind: SDPLoginFilterKind): OSErr;
	INLINE $203C, 16, kSDPPromptForID, $AA5D;



{
SDPNewPanel creates a new panel. You supply the window in which the panel
is to live, the bounds for the panel (which includes both the menu and the list),
whether or not the panel is to be initially visible, the initial RLI (nil for
directories and volumes), the types of records that will be shown (only a single
(non-nil) type which may contain wildcards), the identity by which to browse
(for access control reasons), and a refCon which is  available to the caller.
}
FUNCTION SDPNewPanel(VAR newPanel: SDPPanelHandle;
						window: WindowPtr;
						bounds: Rect;
						visible: BOOLEAN;
						enabled: BOOLEAN;
						initialRLI: PackedRLIPtr;
						typesList: RStringHandle;
						typeCount: LONGINT;
						identity: AuthIdentity;
						enumFlags: DirEnumChoices;
						matchTypeHow: DirMatchWith;
						refCon: LONGINT): OSErr;
	INLINE $203C, 21, kSDPNewPanel, $AA5D;


{
SDPSetIdentity Sets the identity used for browsing.  NOTE: This call is likely to go
away if the new authentication scheme works.
}
FUNCTION SDPSetIdentity(panel: SDPPanelHandle; identity: AuthIdentity): OSErr;
INLINE $203C, 4, kSDPSetIdentity, $AA5D;




{
SDPGetNewPanel is similar to SDPNewPanel above, except it takes a resource id of a
'panl' resource.
}
FUNCTION SDPGetNewPanel(VAR newPanel: SDPPanelHandle;
							resourceID: INTEGER;
							window: WindowPtr;
							initialRLI: PackedRLIPtr;
							identity: AuthIdentity): OSErr;
	INLINE $203C, 9, kSDPGetNewPanel, $AA5D;


{
Call this when you're completely done with a panel. It deallocates all of the
associated data structures.
}
FUNCTION SDPDisposePanel(panel: SDPPanelHandle): OSErr;
	INLINE $203C, 2, kSDPDisposePanel, $AA5D;


{
If the panel is visible, it makes it invisible by hiding the menu, turning off
drawing of the list, and erasing and  invaling the list's rectangle.
}
FUNCTION SDPHidePanel(panel: SDPPanelHandle): OSErr;
	INLINE $203C, 2, kSDPHidePanel, $AA5D;


{ If the panel is invisible, it makes it visible and draws it. }

FUNCTION SDPShowPanel(panel: SDPPanelHandle): OSErr;
	INLINE $203C, 2, kSDPShowPanel, $AA5D;


{ Disables the list and menu so that it won't accept any commands. }

FUNCTION SDPEnablePanel(panel: SDPPanelHandle; enable: BOOLEAN): OSErr;
	INLINE $203C, 3, kSDPEnablePanel, $AA5D;

{
Move the upper-left-hand corner of the panel to (h, v), given in local coordinates of
the panel's window.
}
FUNCTION SDPMovePanel(panel: SDPPanelHandle; h: INTEGER; v: INTEGER): OSErr;
	INLINE $203C, 4, kSDPMovePanel, $AA5D;


{
Resizes the panel to have the given width and height (keeping the upper-left-hand
corner in a fixed position).
}
FUNCTION SDPSizePanel(panel: SDPPanelHandle; width: INTEGER; height: INTEGER): OSErr;
	INLINE $203C, 4, kSDPSizePanel, $AA5D;


{
This routine simulates a double-click on the selected item (if there is no selected
item, then it does nothing), and it returns the result of that "double-click" via the
whatHappened parameter. If a container is selected, then that container will be
opened and kMovedDownTheHierarchy is returned. If, however, the user is at the lowest
level in the hierarchy, then kSDPSelectedAnItem is returned.
}
FUNCTION SDPOpenSelectedItem(panel: SDPPanelHandle; VAR whatHappened: SDPPanelState): OSErr;
	INLINE $203C, 4, kSDPOpenSelectedItem, $AA5D;


{
Returns whether a record is selected, something else is selected, or nothing is
selected.
}
FUNCTION SDPGetPanelSelectionState(panel: SDPPanelHandle; VAR itsState: SDPSelectionState): OSErr;
	INLINE $203C, 4, kSDPGetPanelSelectionState, $AA5D;


{
Returns the size of the currently-selected DSSpec, or zero if a record is
not selected.  It is safe to do a NewPtr (SDPGetPanelSelectionSize (...))
}
FUNCTION SDPGetPanelSelectionSize(panel: SDPPanelHandle; VAR dsSpecSize: INTEGER): OSErr;
	INLINE $203C, 4, kSDPGetPanelSelectionSize, $AA5D;


{
Returns the currently-selected DSSpec, or a zero-lengthed
DSSpec if a record is not selected. It is assumed that the selection
buffer allocated is large enough.
}
FUNCTION SDPGetPanelSelection(panel: SDPPanelHandle; selection: PackedDSSpecPtr): OSErr;
	INLINE $203C, 4, kSDPGetPanelSelection, $AA5D;


{
Forces browsing to the specified RLI. If prli is the current RLI, then it does
nothing.
}
FUNCTION SDPSetPath(panel: SDPPanelHandle; prli: PackedRLIPtr): OSErr;
	INLINE $203C, 4, kSDPSetPath, $AA5D;


{
This is the main driver for the panel.  You should pass all events to SDPPanelEvent
including NULL events.  If you have more than 1 panel, you will need to
call SDPPanelEvent for each panel.  NOTE:  For Update Events you will also need to call
SDPUpdatePanel as described below.
}
FUNCTION SDPPanelEvent(panel: SDPPanelHandle;
							theEvent: EventRecord;
							VAR whatHappened: SDPPanelState): OSErr;
	INLINE $203C, 6, kSDPPanelEvent, $AA5D;



{
SDPUpdatePanel should be called in response to an update event.  Generally you will
have first called BeginUpdate, and pass the windows visRgn as theRgn.  If NULL
is passed for theRgn the entire panel is re-drawn.  NOTE:  Drawing is not cliped to
theRgn, if this is desired, you must first call SetClip.
}
FUNCTION SDPUpdatePanel(panel: SDPPanelHandle; theRgn: RgnHandle): OSErr;
	INLINE $203C, 4, kSDPUpdatePanel, $AA5D;


{
SDPSelectString scrolls and selects the closest matching string at the current
level.  This is the same behavior as if the user typed in the given string.
}
FUNCTION SDPSelectString(panel: SDPPanelHandle; name: RStringPtr): OSErr;
	INLINE $203C, 4, kSDPSelectString, $AA5D;

{
SDPGetPathLength returns the length in bytes required to hold the current path name
in RLI format.  This corresponds to the path name in the popup menu.
}
FUNCTION SDPGetPathLength(panel: SDPPanelHandle; VAR pathNameLength: INTEGER): OSErr;
	INLINE $203C, 4, kSDPGetPathLength, $AA5D;

{ SDPGetPath returns the current rli. }
FUNCTION SDPGetPath(panel: SDPPanelHandle; VAR prli: PackedRLI; VAR dsRefNum: INTEGER): OSErr;
	INLINE $203C, 6, kSDPGetPath, $AA5D;

{
SDPSetFocus will draw the focus rectangle or erase the focus rectangle depending upon
the focus boolean.
}
FUNCTION SDPSetFocus(panel: SDPPanelHandle; focus: BOOLEAN): OSErr;
	INLINE $203C, 3, kSDPSetFocus, $AA5D;

{
SDPSetPanelBalloonHelp allows clients to specify a STR# resource id to use for
balloon help.  Balloon help is unavailable until this call is made.
}
FUNCTION SDPSetPanelBalloonHelp(panel: SDPPanelHandle; balloonHelpID: INTEGER): OSErr;
	INLINE $203C, 3, kSDPSetPanelBalloonHelp, $AA5D;

{
SDPInstallPanelBusyProc allows clients to install a CB that will be called while
the panel is aynchronously busy.
}
FUNCTION SDPInstallPanelBusyProc(panel: SDPPanelHandle; busyProc: PanelBusyProc): OSErr;
	INLINE $203C, 4, kSDPInstallPanelBusyProc, $AA5D;



FUNCTION SDPNewFindPanel(VAR newPanel: SDPFindPanelHandle; window: WindowPtr;
	upperLeft: Point; layoutResourceID: INTEGER; visible: BOOLEAN;
	enabled: BOOLEAN; typesList: RStringHandle;  typeCount: LONGINT;
	matchTypeHow: DirMatchWith; identity: AuthIdentity; simultaneousSearchCount: INTEGER;
	initialFocus: SDPFindPanelFocus; refCon: LONGINT): OSErr;
	INLINE $203C, 20, kSDPNewFindPanel, $AA5D;

FUNCTION SDPDisposeFindPanel(findPanel: SDPFindPanelHandle): OSErr;
	INLINE $203C, 2, kSDPDisposeFindPanel, $AA5D;

FUNCTION SDPStartFind(findPanel: SDPFindPanelHandle): OSErr;
	INLINE $203C, 2, kSDPStartFind, $AA5D;

FUNCTION SDPStopFind(findPanel: SDPFindPanelHandle): OSErr;
	INLINE $203C, 2, kSDPStopFind, $AA5D;

FUNCTION SDPFindPanelEvent(findPanel: SDPFindPanelHandle;
	event: EventRecord; VAR whatHappened: SDPFindPanelResult): OSErr;
	INLINE $203C, 6, kSDPFindPanelEvent, $AA5D;

FUNCTION SDPUpdateFindPanel(findPanel: SDPFindPanelHandle; theRgn: RgnHandle): OSErr;
	INLINE $203C, 4, kSDPDrawFindPanel, $AA5D;

FUNCTION SDPShowFindPanel(findPanel: SDPFindPanelHandle): OSErr;
	INLINE $203C, 2, kSDPShowFindPanel, $AA5D;

FUNCTION SDPHideFindPanel(findPanel: SDPFindPanelHandle): OSErr;
	INLINE $203C, 2, kSDPHideFindPanel, $AA5D;

FUNCTION SDPMoveFindPanel(findPanel: SDPFindPanelHandle; h: INTEGER; v: INTEGER): OSErr;
	INLINE $203C, 4, kSDPMoveFindPanel, $AA5D;

FUNCTION SDPEnableFindPanel(findPanel: SDPFindPanelHandle; enabled: BOOLEAN): OSErr;
	INLINE $203C, 3, kSDPEnableFindPanel, $AA5D;

FUNCTION SDPSetFindPanelFocus(findPanel: SDPFindPanelHandle;
	newFocus: SDPFindPanelFocus): OSErr;
	INLINE $203C, 3, kSDPSetFindPanelFocus, $AA5D;

FUNCTION SDPGetFindPanelState(findPanel: SDPFindPanelHandle; VAR itsState: SDPFindPanelState): OSErr;
	INLINE $203C, 4, kSDPGetFindPanelState, $AA5D;

FUNCTION SDPGetFindPanelSelectionSize(findPanel: SDPFindPanelHandle;
	VAR size: INTEGER): OSErr;
	INLINE $203C, 4, kSDPGetFindPanelSelectionSize, $AA5D;

FUNCTION SDPGetFindPanelSelection(findPanel: SDPFindPanelHandle;
	VAR selection: PackedDSSpec): OSErr;
	INLINE $203C, 4, kSDPGetFindPanelSelection, $AA5D;

FUNCTION SDPSetFindPanelBalloonHelp(findPanel: SDPFindPanelHandle;
	balloonHelpID: INTEGER): OSErr;
	INLINE $203C, 3, kSDPSetFindPanelBalloonHelp, $AA5D;

FUNCTION SDPSetFindIdentity(findPanel: SDPFindPanelHandle;
	identity: AuthIdentity): OSErr;
	INLINE $203C, 4, kSDPSetFindIdentity, $AA5D;

FUNCTION SDPInstallFindPanelBusyProc(findPanel: SDPFindPanelHandle; busyProc: FindPanelBusyProc): OSErr;
	INLINE $203C, 4, kSDPInstallFindPanelBusyProc, $AA5D;



FUNCTION SDPGetIconByType(recordType: RStringPtr;
							  whichIcons: IconSelectorValue;
							  VAR iconSuite: Handle): OSErr;
							  INLINE $303C, kSDPGetIconByType, $AA5C;

FUNCTION SDPGetDSSpecIcon(packedDSSpec: PackedDSSpecPtr;
							  whichIcons: IconSelectorValue;
							  VAR iconSuite: Handle): OSErr;
							  INLINE $303C, kSDPGetDSSpecIcon, $AA5C;

FUNCTION SDPGetCategories(VAR catagories: PackedRStringListHandle;
						  VAR displayNames: PackedRStringListHandle): OSErr;
							  INLINE $303C, kSDPGetCategories, $AA5C;

FUNCTION SDPGetCategoryTypes(category: RStringPtr;
								 VAR types: PackedRStringListHandle): OSErr;
								 INLINE $303C, kSDPGetCategoryTypes, $AA5C;



FUNCTION SDPResolveAliasFile(fileSpec: FSSpecPtr;
								 resolvedDSSpec: PackedDSSpecHandle;
								 identity: AuthIdentity;
								 mayPromptUser: BOOLEAN): OSErr;
					INLINE $203C, 7, kSDPResolveAliasFile, $AA5D;

FUNCTION SDPResolveAliasDSSpec(theAliasDSSpec: PackedDSSpecHandle;
								   identity: AuthIdentity;
								   mayPromptUser: BOOLEAN): OSErr;
					INLINE $203C, 5, kSDPResolveAliasDSSpec, $AA5D;

FUNCTION SDPRepairPersonalDirectory(pd: FSSpecPtr; showProgress: BOOLEAN): OSErr;
					INLINE $203C, 3, kSDPRepairPersonalDirectory, $AA5D;



{$ENDC}    { UsingOCEStandardDirectory }

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
