/*								AttributeValueLDEF.c						*/
/*
 * DTS Catalog Peek
 * AttributeValueLDEF.c
 * Copyright  1993 Apple Computer Inc. All rights reserved.
 *
 * These functions display the attribute value list entry.
 * Attribute value entries contain the attribute type (RString),
 * creation id, attribute tag, and a handle to the data.
 * This LDEF displays the type, id, and tag, but does not
 * examine or display the handle contents.
 */
#include "DTSCatalogPeek.h"
#ifndef THINK_C
#include <SysEqu.h>
#endif
#pragma segment SupportCode

/*
 * Draw the attribute types. The cell contains an RString.
 */
pascal void
AttributeValueLDEF(
		short							listMessage,
		Boolean							listSelect,
		Rect							*listRect,
		Cell							listCell,
		short							listDataOffset,
		short							listDataLen,
		ListHandle						listHandle
	)
{
#pragma unused (listCell)
#define LIST	(**listHandle)

		register CatalogBrowserPtr		dbp;
		AttributeHeaderInfo				info;
		Point							penPt;
		Rect							viewRect;
		Str255							work;
		unsigned char					*cp;
		short							i;
	
		/*
		 * Make sure the list is locked down while we draw.
		 */
		dbp = (CatalogBrowserPtr) LIST.refCon;
		switch (listMessage) {
		case lInitMsg:
			break;
		case lDrawMsg:
			EraseRect(listRect);
			viewRect = *listRect;
			viewRect.left += LIST.indent.h;
			if (listDataLen > 0) {
				if (listDataLen != sizeof info) {
					DrawWideString(
						"\pAttribute list data size error",
						&viewRect,
						italic
					);
				}
				else {
					BlockMove(
						(*LIST.cells) + listDataOffset,
						&info,
						sizeof info
					);
					TextFont(DBR.valueFont.fontNumber);
					TextSize(DBR.valueFont.fontSize);
					/*
					 * Display the fixed-size content from the
					 * Attribute Header record.
					 */
					SetPt(
						&penPt,
						viewRect.left,
						viewRect.top + DBR.valueFont.info.ascent
					);
					MoveTo(penPt.h, penPt.v);
					work[0] = 0;
					cp = (unsigned char *) &info.cid;
					for (i = 0; i < sizeof (AttributeCreationID); i++)
						AppendHexLeadingZeros(work, *cp++, 2);	/* 2 digits in 1 byte	*/
					AppendChar(work, ' ');
					AppendOSType(work, (OSType) info.tag);
					DrawString(work);
					penPt.h += StringWidth("\p0000000000000000 'MMMM' ");
					MoveTo(penPt.h, penPt.v);
					TextFont(DBR.typeFont.fontNumber);	/* Times						*/
					TextSize(DBR.typeFont.fontSize);	/* Should be the same size		*/
					viewRect.left = penPt.h;
					DrawRString((RStringPtr) &info.attributeType, &viewRect, normal);
				}
			}
			if (listSelect == FALSE)
				break;
			/* Continue to do hilite */
		case lHiliteMsg:
#ifdef THINK_C
			HiliteMode &= ~(1 << hiliteBit);
#else /* MPW */
			*((char *) HiliteMode) &= ~(1 << hiliteBit);	/* Inside Mac V-61	*/
#endif
			InvertRect(listRect);
			break;
		}
#undef LIST
}



