/*									BalloonHelp.r								*/
/*
 * DTS Catalog Peek
 * BalloonHelp.r
 * Copyright  1993 Apple Computer Inc. All rights reserved.
 * These are the balloon help resources for DTS Catalog Peek. This file
 * can be compiled by MPW Rez and by Think C 6.0 Rez.
 */
#include "Types.r"
#include "SysTypes.r"
#include "BalloonTypes.r"
#include "DTSCatalogPeek.h"

#define kApplicationName	"DTS Catalog Peek"

/*
 * This resource provides a help balloon for the application file itself
 * file itself.
 */
resource 'hfdr' (kHMHelpID, "Application Help", purgeable) {
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
		HMStringItem {
			kApplicationName " lets you browse through AOCE Catalogs."
		}
	}
};

	
/*
 * Help for menu items.
 */
resource 'hmnu' (MENU_Apple, "Apple", purgeable) {
	HelpMgrVersion,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {	/* No missing item text */
	},
	{
		HMStringItem {
			"Use this menu to select Apple Menu items",
			"", "", "",
		},
		HMStringItem {
			"Displays the tutorial help dialog window.",
			"", "", "",
		}
	}
};

resource 'hmnu' (MENU_File, "File", purgeable) {
	HelpMgrVersion,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {	/* No missing item text */
	},
	{
		HMStringItem {
			"Use this menu to control " kApplicationName ".",
			"",
			"This menu\0xD5s not available; respond to the dialog box.",
			"This command\0xD5s not available; respond to the dialog box.",
		},
		HMStringItem {
			"Create a new Catalog browsing window.",
			"", "", "",
		},
		HMStringItem {
			"Close the Catalog window. "
			kApplicationName " exits when the last window is closed",
			"", "", "",
 		};
		HMSkipItem {},							/* Separator line			*/
		HMStringItem {
			"Save the current Catalog window.",
			"Save the current Catalog window."
			" Not available as the code hasn't been written yet.",
			"", "",
		},
		HMSkipItem {},
		HMStringItem {
			"Specify the user identity.",
			"", "", "",
		},
		HMSkipItem {},
		HMStringItem {
			"Exit the application.",
			"", "", "",
		}
	}
};

/*
 * Help resources for the browser window. Items are ordered to match the rectangle
 * definitions. Some items have differing texts depending on what the rectangle
 * actually contains at this very instant.
 */
resource 'STR ' (HELP_Browser, "Help menu item", purgeable) {
		kApplicationName " Help"
};

resource 'hdlg' (HELP_Browser, "Main window help", purgeable) {
	HelpMgrVersion,
	0,
	hmDefaultOptions,
	0,
	7,
	HMSkipItem {},
	{
		HMStringItem {							/* kInSDPPanel					*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This is the Standard Catalog Panel.",		/* kHMEnabledItem		*/
			"This is your Personal Catalog.",			/* kHMDisabledItem		*/
			"This is the AOCE Setup Catalog.",			/* kHMCheckedItem		*/
			"" /* Nothing visible */					/* kHMOtherItem			*/
 		},
		HMStringItem {							/* kInAttributeTypeList			*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This list shows all attribute types"		/* kHMEnabledItem		*/
				" for the catalog record you have selected.",
			"This list shows all attribute types"		/* kHMDisabledItem		*/
				" for a selected catalog record,"
				" however no catalog record is selected, or"
				" the record has no attributes.",
			"", ""
 		},
		HMStringItem {							/* kInAttributeValueList		*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This list shows all values defined"		/* kHMEnabledItem		*/
				" for the attribute type you have selected.",
			"This list shows all values defined"		/* kHMDisabledItem		*/
				" for a selected attribute type,"
				" however no attribute type is selected.",
			"", ""
 		},
		HMStringItem {							/* kInDataDisplayList			*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This list shows the data for the"			/* kHMEnabledItem		*/
				" value you have selected.",
			"This list shows the data for a"			/* kHMEnabledItem		*/
				" selected value,"
				" however no value is selected.",
			"This list shows the internal"				/* kHMCheckedItem		*/
				" structure of the catalog record"
				" or folder you have selected.",
			"This list shows the internal"				/* kHMOtherItem			*/
				" structure or a catalog record or folder,"
				" however no record or folder is selected."
 		},
		HMStringItem {							/* kInRecordLengthText			*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This is the length in bytes of the"		/* kHMEnabledItem		*/
				" value that is being displayed.",
			"This area will show the length in bytes"	/* kHMDisabledItem		*/
				" of an attribute value datum, however"
				" none is being displayed at this time.",
			"",											/* kHMCheckedItem		*/
			""
		},
		HMStringItem {							/* kInErrorLog					*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This displays messages and "				/* kHMEnabledItem		*/
				" non-fatal error status values.",
			"", "", ""
		},
		HMStringItem {							/* kInSDPCatalogIcon			*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"These are the icons displayed by the"		/* kHMEnabledItem		*/
			" high-level icon display function.",
			"", "", ""
		},
		HMStringItem {							/* kInGetCatalogIconPopup		*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"Use his popup menu to choose which"		/* kHMEnabledItem		*/
			" low-level icon to display.",
			"", "", ""
		},
		HMStringItem {							/* kInGetCatalogIconItself	*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This is the icon retrieved using a"		/* kHMEnabledItem		*/
			" low-level catalog icon function.",
			"", "", ""
		},
		HMStringItem {							/* kInLocalRecordName			*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This shows the name of the"				/* kHMEnabledItem		*/
				" catalog record you have selected.",
			"This shows the name of a catalog"			/* kHMDisabledItem		*/
				" record, however none is selected.",
			"", ""
 		},
		HMStringItem {							/* kInLocalRecordType			*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This shows the type of the"				/* kHMEnabledItem		*/
				" catalog record you have selected.",
			"This shows the type of the"				/* kHMDisabledItem		*/
				" a catalog record, however none is selected.",
			"", ""
 		},
		HMStringItem {							/* kInBrowsePopup				*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"Use this popup menu to choose which"		/* kHMEnabledItem		*/
			" catalog to display.",
			"", "", ""
		},
		HMStringItem {							/* kInShowEntityRadioButton		*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"To display the record data content,"		/* kHMEnabledItem		*/
				" click on this button.",
			"Display the record data content.",			/* kHMDisabledItem		*/
			 "The record data is displayed"				/* kHMCheckedItem		*/
			 	" at the bottom of the display.",
			 ""											/* kHMOtherItem			*/
		},
		HMStringItem {							/* kInShowDSSpecRadioButton		*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"To display the expanded catalog,"			/* kHMEnabledItem		*/
				" click on this button.",
			"Display the expanded catalog. Disabled"	/* kHMDisabledItem		*/
				" as a Browser Panel is not displayed.",
			 "The expanded catalog is displayed in"		/* kHMCheckedItem		*/
			" at the bottom of the display.",
			""
		},
		HMStringItem {							/* kInSpinnerRect				*/
			{ 0, 0 }, { 0, 0, 0, 0 },
			"This spins when the SDP Panel is"			/* kHMEnabledItem		*/
				" busy carrying out its arduous tasks.",
			 "", "", ""
		},
	}
};		
 			
/*
 * Help resources for the help dialog.
 */
resource 'hdlg' (DLOG_Help, "Help dialog help", purgeable) {
	HelpMgrVersion,
	0,
	hmDefaultOptions,
	0,
	7,
	HMSkipItem {},
	{
		HMStringItem {
			{ 0, 0 }, { 0, 0, 0, 0 },
			"To close the help dialog, click this button.",
			"", "", "",
 		},
 		HMStringItem {
 			{ 0, 0 }, { 0, 0, 0, 0 },
 			"To select the previous topic, click this button.",
 			"Select the previous topic. Disabled as this is the first topic.",
 			"", ""
 		},
 		HMStringItem {
 			{ 0, 0 }, { 0, 0, 0, 0 },
 			"To select the next topic click this button.",
 			"Select the next topic. Disabled as this is the last topic.",
 			"", ""
 		},
  		HMStringItem {
 			{	((239 -  10) / 2), ((465 - 172) / 2) },
 			{ 0, 0, 0, 0 },
 			"This area contains information about the selected topic.",
 			"", "", ""
 		},
 		HMStringItem {
 			{	((239 -  10) / 2), ((165 -   7) / 2) },
 			{ 0, 0, 0, 0 },
 			"Click on an item in this list to select a topic to view.",
 			"", "", ""
 		}
	}
};

/*
 * Help resources for the help menu.
 */
resource 'hmnu' (kHMHelpMenuID, "Help", purgeable) {
	HelpMgrVersion, 0, 0, 0,
	HMSkipItem { },
	{
		HMStringItem {
/* 1 */		"Displays tutorial help for " kApplicationName ".",
/* 2 */		"",				/* Never dimmed */
/* 3 */		"Closes tutorial help for " kApplicationName ".",
/* 4 */		"",
		},
	}
};

