/*									DTSCatalogPeek.r							*/
/*
 * DTS Catalog Peek
 * DTSCatalogPeek.r
 * Copyright  1993 Apple Computer Inc. All rights reserved.
 * These are the resource definitions for DTS Catalog Peek. This file
 * can be compiled by MPW Rez and by Think C 6.0 Rez.
 */
#include "Types.r"
#include "SysTypes.r"
#include "DTSCatalogPeek.h"
#ifndef THINK_Rez
include "::DTS Catalog Peek Help.rsrc";
include "::DTS Catalog Peek Icons.rsrc";
#endif


resource 'FREF' (ICON_Application) {
	'APPL',
	0,
	""
};

resource  'BNDL' (128) {
	kApplicationCreator,
	0,
	{	/* array TypeArray: 1 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			0, ICON_Application,
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 1 elements */
			0, ICON_Application,
		}
	}
};

resource 'STR#' (STRN_Parameters, "Display parameters") {
	{	/* array StringArray: 6 elements */
		"Palatino",
		"Geneva",
		"Times",
		"Geneva",
		"Courier",
		"12"
	}
};

resource 'MBAR' (MBAR_MenuBar) {
	{	/* array MenuArray: 3 elements */
		MENU_Apple,
		MENU_File,
		MENU_Edit
	}
};

resource 'MENU' (MENU_Apple, "Apple Menu") {
	MENU_Apple,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		"About DTS Catalog Peek", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (MENU_File, "File Menu") {
	MENU_File,
	textMenuProc,
	0x0,
	enabled,
	"File",
	{	/* array: 8 elements */
		"New Browser Window", noIcon, "N", noMark, plain,
		"Close Window", noIcon, "W", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Save As Text", noIcon, "S", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Set User Identity", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Quit", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (MENU_Edit, "Edit Menu") {
	MENU_Edit,
	textMenuProc,
	0x0,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		"Undo", noIcon, "Z", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Cut", noIcon, "X", noMark, plain,
		"Copy", noIcon, "C", noMark, plain,
		"Paste", noIcon, "V", noMark, plain,
		"Clear", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (MENU_Icons, "Icon Menu") {
	MENU_Icons,
	textMenuProc,
	allEnabled,
	enabled,
	"Icons",
	{	/* array: 6 elements */
		"icl8", noIcon, noKey, noMark, plain,
		"icl4", noIcon, noKey, noMark, plain,
		"ICN#", noIcon, noKey, noMark, plain,
		"ics8", noIcon, noKey, noMark, plain,
		"ics4", noIcon, noKey, noMark, plain,
		"ics#", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (MENU_Browser, "Browser Menu") {
	MENU_Browser,
	textMenuProc,
	allEnabled,
	enabled,
	"Browse",
	{	/* array: 3 elements */
		"Browse SDP Panel", noIcon, noKey, noMark, plain,
		"Browse Personal Catalog", noIcon, noKey, noMark, plain,
		"Browse Setup Catalog", noIcon, noKey, noMark, plain,
		"Browse Setup Record", noIcon, noKey, noMark, plain
	}
};

resource 'WIND' (WIND_Browser, "Browser Window") {
		{ 0, 0, kMinWindowHeight, kMinWindowWidth },
		zoomDocProc,
		invisible,
		goAway,
		0x0,
		"DTS Catalog Peek"
};
		
resource 'DITL' (ALRT_NonFatal, "System Error") {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{84, 265, 104, 334},
		Button {
			enabled,
			"Continue"
		},
		/* [2] */
		{83, 185, 103, 243},
		Button {
			enabled,
			"Exit"
		},
		/* [3] */
		{10, 20, 42, 52},
		UserItem {
			disabled
		},
		/* [4] */
		{7, 74, 71, 331},
		StaticText {
			disabled,
			"System Error ^0 ^1 ^2 ^3"
		}
	}
};

resource 'DITL' (ALRT_Fatal, "Fatal System Error") {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{84, 265, 104, 334},
		Button {
			enabled,
			"Exit"
		},
		/* [2] */
		{7, 74, 71, 331},
		StaticText {
			disabled,
			"Fatal System Error ^0 ^1 ^2 ^3"
		},
		/* [3] */
		{10, 20, 42, 52},
		UserItem {
			disabled
		}
	}
};

resource 'DITL' (ALRT_Continue, "Continue Error") {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{84, 255, 104, 335},
		Button {
			enabled,
			"Continue"
		},
		/* [2] */
		{7, 74, 71, 331},
		StaticText {
			disabled,
			"System Error ^0 ^1 ^2 ^3"
		},
		/* [3] */
		{10, 20, 42, 52},
		UserItem {
			disabled
		}
	}
};

/*
 * The 'hdlg' refers to the item locations.
 */
resource 'DITL' (DLOG_Help, "Help") {
	{	/* array DITLarray: 5 elements */
		{243, 200, 262, 272}, Button	{ enabled,			"OK"				},
		{243,  80, 262, 160}, Button	{ enabled,			"Prev"				},
		{243, 312, 262, 392}, Button	{ enabled,			"Next"				},
		{ 10, 172, 239, 465}, UserItem	{ enabled								},
		{ 10,   7, 239, 165}, UserItem	{ enabled								},
		{  0,   0,   0,   0}, HelpItem	{ disabled, HMScanhdlg { DLOG_Help }	},
	}
};

resource 'dctb' (ALRT_NonFatal, "System Error", purgeable) {
	{	/* array ColorSpec: 0 elements */
	}
};

resource 'dctb' (ALRT_Fatal, "Fatal System Error", purgeable) {
	{	/* array ColorSpec: 0 elements */
	}
};

resource 'dctb' (ALRT_Continue, "Continue Error", purgeable) {
	{	/* array ColorSpec: 0 elements */
	}
};

resource 'dctb' (DLOG_Help, "Help", purgeable) {
	{	/* array ColorSpec: 0 elements */
	}
};

resource 'ALRT' (ALRT_Fatal, "Fatal Error Alert") {
	{89, 84, 204, 430},
	9010,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'ALRT' (ALRT_NonFatal, "System Error Alert") {
	{89, 84, 205, 427},
	9000,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'ALRT' (ALRT_Continue, "Continue Alert") {
	{89, 84, 204, 430},
	9020,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'DLOG' (DLOG_Help, "Help") {
	{0, 0, 284, 472},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	4000,
	""
};

resource 'vers' (1) {
	0x1,
	0x0,
	release,
	0x0,
	verUS,
	"1.0",
	"1.0  1993 Apple Computer Inc. All Right"
	"s Reserved"
};

resource 'vers' (2) {
	0x1,
	0x0,
	release,
	0x0,
	verUS,
	"1.0",
	"For AOCE 1.0"
};

resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	393216,
	393216
};

