/*								DataDisplayLDEF.c							*/
/*
 * DTS Catalog Peek
 * DataDisplayLDEF.c
 * Copyright  1993 Apple Computer Inc. All rights reserved.
 *
 * This list definition draws the data display list. The
 * content is a normal string.
 */
#include "DTSCatalogPeek.h"
#ifndef THINK_C
#include <SysEqu.h>
#endif
#pragma segment SupportCode

/*
 * Draw the attribute types. The cell contains normal text.
 * The cell cannot be selected.
 */
pascal void
DataDisplayLDEF(
		short							listMessage,
		Boolean							listSelect,
		Rect							*listRect,
		Cell							listCell,
		short							listDataOffset,
		short							listDataLen,
		ListHandle						listHandle
	)
{
#pragma unused (listCell)
#define LIST	(**listHandle)

		Boolean							cellLockState;
		register CatalogBrowserPtr		dbp;
		Rect							viewRect;
		
		/*
		 * Make sure the list is locked down while we draw.
		 */
		dbp = (CatalogBrowserPtr) LIST.refCon;
		switch (listMessage) {
		case lInitMsg:
			break;
		case lDrawMsg:
			EraseRect(listRect);
			if (listDataLen > 0) {
				/*
				 * Data is just a normal string.
				 */
				TextFont(DBR.dataFont.fontNumber);
				TextSize(DBR.dataFont.fontSize);
				cellLockState = HGetState(LIST.cells);
				viewRect = *listRect;
				viewRect.left += LIST.indent.h;
				HLock(LIST.cells);
				DrawWideText(
					*LIST.cells,
					listDataOffset,
					listDataLen,
					&viewRect,
					normal
				);
				HSetState(LIST.cells, cellLockState);
			}
			if (listSelect == FALSE)
				break;
			/* Continue to do hilite */
		case lHiliteMsg:
#if 0
			/*
			 * The data display list content can't be selected.
			 */
#ifdef THINK_C
			HiliteMode &= ~(1 << hiliteBit);
#else /* MPW */
			*((char *) HiliteMode) &= ~(1 << hiliteBit);	/* Inside Mac V-61	*/
#endif
			InvertRect(listRect);
#endif
			break;
		}
#undef LIST
}



