/*							DrawCatalogListCell.c							*/
/*
 * DTS Catalog Peek
 * DrawCatalogListCell.c
 * Copyright  1993 Apple Computer Inc. All rights reserved.
 *
 * This function draws the directory display list datum. It is called by
 * the TwistDown list LDEF.
 */
#include "DTSCatalogPeek.h"
#pragma segment SupportCode

pascal void
DrawCatalogListCell(
		ListHandle						twistDownListHdl,
		const Ptr						dataPtr,
		unsigned short					dataLength,
		const Rect						*viewRect
	)
{
			
		register CatalogBrowserPtr		dbp;
		unsigned short					textLength;
#define LIST	(**twistDownListHdl)
#define ELEM	(* ((ElementPtr) dataPtr))

		dbp = (CatalogBrowserPtr) LIST.refCon;
		if (dbp != NULL) {
			textLength = dataLength - ELEM_HEADER_SIZE;
			switch (ELEM.header.format) {
			case kElementString:
			case kElementMessage:
				TextFont(DBR.valueFont.fontNumber);
				TextSize(DBR.valueFont.fontSize);
				DrawWideText(
					(Ptr) ELEM.data,
					0,
					textLength,
					viewRect,
					(ELEM.header.format == kElementString) ? normal : italic
				);
				break;
			case kElementRString:
				TextFont(DBR.typeFont.fontNumber);
				TextSize(DBR.typeFont.fontSize);
				DrawRString(
					(RStringPtr) ELEM.data,
					viewRect,
					normal
				);
				break;
			case kElementCode:
				TextFont(DBR.dataFont.fontNumber);
				TextSize(DBR.dataFont.fontSize);
				DrawWideText(
					(Ptr) ELEM.data,
					0,
					textLength,
					viewRect,
					normal
				);
				break;
			}
		}
#undef LIST
#undef ELEM
}



