/*							GetHelpItemIndex.c								*/
/*
 * DTS Catalog Peek
 * GetHelpItemIndex.c
 * Copyright  1993 Apple Computer Inc. All rights reserved.
 *
 */
#include "DTSCatalogPeek.h"
#include <Balloons.h>
#pragma segment SupportCode

#define HAS_CONTENT(list)	((**list).dataBounds.bottom != 0)
#define LIST_SELECT(list)	(HAS_CONTENT(list) ? kHMEnabledItem : kHMDisabledItem)
/*
 * GetHelpItemIndex is used by the balloon help function to select
 * the proper item text to use.
 */
short
GetHelpItemIndex(
		register CatalogBrowserPtr		dbp,
		short							index		/* Current rectangle	*/
	)
{
		short							result;

		switch (index) {
		case kInSDPPanel:
			switch (DBR.browserChoice) {
			default:
			case kBrowseSDPPanel:		result = kHMEnabledItem;	break;
			case kBrowsePDPanel:		result = kHMDisabledItem;	break;
			case kBrowseSetupCatalog:	result = kHMCheckedItem;	break;
			case kBrowseSetupRecord:	result = kHMOtherItem;		break;
			}
			break;
		case kInAttributeTypeList:
			result = LIST_SELECT(DBR.attributeTypeList);
			break;
		case kInAttributeValueList:
			result = LIST_SELECT(DBR.attributeValueList);
			break;
		case kInDataDisplayList:
			if (DBR.showCatalog)
				result = LIST_SELECT(DBR.directoryDisplayList) + kHMCheckedItem;
			else {
				result = LIST_SELECT(DBR.dataDisplayList);
			}
			break;
		case kInRecordLengthText:
			/*
			 * Note: there is no text for the record length item if we're
			 * showing the directory, so the balloon shouldn't be displayed.
			 */
			if (DBR.showCatalog)
				result = kHMCheckedItem;
			else {
				result = LIST_SELECT(DBR.dataDisplayList);
			}
			break;
		case kInLocalRecordName:
			result = IsRStringHandle(DBR.recordName)
						? kHMEnabledItem : kHMDisabledItem;
			break;
		case kInLocalRecordType:
			result = IsRStringHandle(DBR.recordType)
						? kHMEnabledItem : kHMDisabledItem;
			break;
		case kInShowEntityRadioButton:
			if ((**DBR.showEntityRadioControl).contrlHilite != 0)
				result = kHMDisabledItem;
			else if (GetCtlValue(DBR.showEntityRadioControl) != 0)
				result = kHMCheckedItem;
			else {
				result = kHMEnabledItem;
			}
			break;
		case kInShowCatalogRadioButton:
			if ((**DBR.showDSSpecRadioControl).contrlHilite != 0)
				result = kHMDisabledItem;
			else if (GetCtlValue(DBR.showDSSpecRadioControl) != 0)
				result = kHMCheckedItem;
			else {
				result = kHMEnabledItem;
			}
			break;
		case kInErrorLog:
		case kInSDPCatalogIcon:
		case kInGetCatalogIconPopup:
		case kInGetCatalogIconItself:
		case kInBrowsePopup:
		case kInSpinnerRect:
		default:
			result = kHMEnabledItem;
			break;
		}
		return (result);
}


