/*								GetSetupCatalogInfo.c							*/
/*
 * DTS Catalog Peek
 * GetSetupCatalogInfo.c
 * Copyright  1993 Apple Computer Inc. All rights reserved.
 *
 */
#include "DTSCatalogPeek.h"
#pragma segment MainCode

/*
 * GetSetupCatalogInfo
 * Get the OCESetup Catalog refNum and Setup Record
 * creation ID. Fail on errors.
 *
 * Globals:
 *	DBR.setupCatalogRefNum
 *			Returns the Setup Catalog refNum.
 *	SETUP_REC_RecordID
 *			Contains the Local Record ID for the setup record.
 */
void
GetSetupCatalogInfo(
		register CatalogBrowserPtr		dbp
	)
{
		OSErr					status;
		
#define GET	(PB.dirGetOCESetupRefNumPB)

		CLEAR(GET);
		GET.identity = DBR.userIdentity;
		status = DirGetOCESetupRefNum(&PB, SYNC);
		LOG(status, "\pDirGetOCESetupRefNum");
		FailOSErr(status);
		/*
		 * To browse the setup record, use the
		 * setup directory refNum and create
		 * a record id that specifies the
		 * setup record itself.
		 */
		DBR.setupCatalogRefNum = GET.dsRefNum;
		OCECopyCreationID(
			&GET.oceSetupRecordCID,
			&SETUP_REC_RecordID.local.cid
		);
		SETUP_REC_RecordID.local.recordName = NULL;
		SETUP_REC_RecordID.local.recordType = NULL;
		SETUP_REC_RecordID.rli = NULL;
		SETUP_REC_PDRefNum = DBR.setupCatalogRefNum;
}
