/*								ManageUserIdentity.c							*/
/*
 * DTS Catalog Peek
 * ManageUserIdentity.c
 * Copyright  1993 Apple Computer Inc. All rights reserved.
 *
 * Store the current user identity, or zero if none was set.
 *
 * Globals
 *	DBR.userIdentity
 *			Gets the current identity.
 *	DBR.panelHandle
 *			If present, the new identity will be given to
 *			the panel.
 */
#include "DTSCatalogPeek.h"
#pragma segment MainCode

void
SetUserIdentity(
		register CatalogBrowserPtr		dbp
	)
{
		AuthParamBlock			authParamBlock;
		OSErr					status;
		
		status = AuthGetLocalIdentity(&authParamBlock, SYNC);
		if (status == noErr) {
			DBR.userIdentity =
				authParamBlock.getLocalIdentityPB.theLocalIdentity;
		}
		else if (status = kOCELocalAuthenticationFail)
			DBR.userIdentity = 0;
		else {
			Failure(status);
		}
}

void
SetSpecificIdentity(
		register CatalogBrowserPtr		dbp
	)
{
		SDPIdentityKind			selectedKind;
		OSErr					status;
		
		status = SDPPromptForID(
				&DBR.userIdentity,		/* AuthIdentity		*id				*/ 
				NULL,					/* Default guest prompt				*/
				NULL,					/* Default specific prompt			*/
				NULL,					/* Default local prompt				*/
				NULL,					/* RString			*recordType		*/
				(						/* SDPIdentityKind	permittedKinds	*/
					kSDPLocalIdentityMask		/* Local identity			*/
					| kSDPSpecificIdentityMask	/* or specific identity		*/
					| kSDPGuestMask				/* Or guest identity		*/
				),
				&selectedKind,			/* SDPIdentityKind	*selectedKind	*/
				NULL,					/* RecordID			*loginFilter	*/
				0						/* SDPLoginFilterKind filterKind	*/						
			);
		FailOSErr(status);
		if (DBR.panelHandle != NULL) {
			FailOSErr(
				SDPSetIdentity(DBR.panelHandle, DBR.userIdentity)
			);
		}
		if (DBR.pdPanelHandle != NULL) {
			FailOSErr(
				SDPSetIdentity(DBR.pdPanelHandle, DBR.userIdentity)
			);
		}
}
