/*					ChangeRecordSelection.c				*/
/*
 * DTS Directory Peek
 * ChangeRecordSelection.c
 * Copyright  1993 Apple Computer Inc. All rights reserved.
 *
 * These functions open and close the personal address book.
 */
#include "DTSDirectoryPeek.h"

void
ChangeRecordSelection(
		register DirectoryBrowserPtr	directoryBrowserPtr
	)
{
		/*
		 * Before ChangeRecordSelection is called, the
		 * user has selected a directory element, and the
		 * panel manager has called SDPGetPanelSelection
		 * to extract the current selection. It is then
		 * unpacked to obtain the following data:
		 *	DBR.selectedDSSpec		The current (packed)
		 *							directory specification.
		 *	DBR.theDSSpec			The unpacked DSSpec.
		 *	DBR.theRecord			The associated record ID.
		 * This function calls functions to extract relevant
		 * information from the DSSPec.
		 *
		 * Note: we can also be called with *NO* selection:
		 * in this case, the function clears out the various
		 * lists and other junque.
		 */
		RefreshDirectoryIcons(directoryBrowserPtr);
		ClearAttributeTypeList(directoryBrowserPtr);
		if (DBR.selectedDSSpec != NULL) {
			FailOSErr(
				SDPGetDSSpecIcon(
					DBR.selectedDSSpec,		/* This directory	*/
					svAllAvailableData,		/* All icons		*/
					&DBR.iconSuite			/* Store it here	*/
				)
			);
		}
}

