/*
 * DemoApp.h
 * Digital Signature demo application class. This is
 * defined as a subclass of the Think Class Library
 * CEditApp sample application. It adds "Sign File"
 * and "Verify File" menu items and their associated
 * methods.
 *
 */

#define	_H_DemoApp		/* Include this file only once */
#include "CEditApp.h"
#include "Demo.h"

class				DemoSignedObject;
class				DemoSignedObjectDialog;

struct DemoApp : CEditApp {
private:
		DemoSignedObject			*itsDemoSignedObject;
		DemoSignedObjectDialog		*itsDemoSignedObjectDialog;

public:
		void					IDemoApp(void);
		void					RemovePatches(void);
		void					SetUpFileParameters(void);
	    void					SetUpMenus(void); 
		void					DoCommand(
			long					theCommand
		);
	    void					UpdateMenus(void);
	    void					OpenDocument(
	    	SFReply					*macSFReply
	    );
		void					OpenSignedDocument(
			SFReply					*macSFReply
		);
		void					CreateSignedDocument(void);
};
