/*
 * DemoSignedObject.h
 * This illustrates how Digital Signatures may be attached
 * to a random object.
 */
#define _H_DemoSignedObject
#include "CSignedObject.h"
class			CDataFile;


struct DemoSignedObject : CSignedObject {
public:
	unsigned short			itsCheckBoxValue;
	unsigned short			itsRadioButtonValue;
	Str255					itsCommentaryText;

private:
		CDataFile				*itsSignatureDataFile;

public:
		void					IDemoSignedObject(void);
		unsigned short			GetCheckBoxValues(void);
		void					SetCheckBoxValues(
			unsigned short			newCheckBoxValues
		);
		unsigned short			GetRadioButtonValue(void);
		void					SetRadioButtonValue(
			unsigned short			newRadioButtonValue
		);
		void					GetCommentaryText(
			StringPtr				resultText
		);
		void					SetCommentaryText(
			const StringPtr			newText
		);
		Boolean					SignThisObject(void);
		Boolean					VerifyThisObject(void);
		void					SaveObjectSignature(void);
		void					ReadObjectSignature(void);
		void					ProcessObject(void);
};

