/*----------------------------------------------------------

AOCE Post Office Protocol (3)
Personal Gateway

written by Steven Falkenburg-- MacDTS
1991 Apple Computer, Inc.

----------------------------------------------------------*/

#pragma once

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __MYTYPES__
#include "mytypes.h"
#endif

#ifndef __PROCESSES__
#include <Processes.h>
#endif

/* application-level globals */

extern	Boolean		gDone;						// set to true when program should quit
extern	Boolean		gWakeUp;					// make sure wakeupprocess affects the next wne
extern	Boolean		gWakeUpSecondary;			// make sure wakeupprocess affects the next wne
extern	ProcessSerialNumber gOurPSN;			// process serial # for wakeupprocess

/* AOCE globals */

extern	Boolean		gAOCEInited;				// true if AOCE has been inited
extern	short		gNumSlots;					// # of slots
extern	SlotSpec	gSlotDatabase[kMaxSlots+1];	// slot database in memory
extern	CreationID	gMSAMCID;					// creation ID of gateway (MSAM)
extern	CreationID	gAOCESetupCID;				// creation ID of the AOCE setup directory
extern	short		gAOCESetupDSRef;				// ds refnum of the AOCE setup directory
extern	LocalIdentity gLocalIdentity;			// the computer's local identity
extern	Boolean		gLocalIdentityUnlocked;		// true once the user authenticates locally
extern	Boolean		gAuthUnlocked;				// true if the local identity is unlocked
extern	Boolean		gAuthRefresh;				// true if the dir identities need to be refreshed
extern	short		gAuthInCriticalSection;		// semaphore indicating when the ID can't be locked
extern	Boolean		gUpdateSlotInformation;		// true when we need to re-read slot information
extern	HLEventQ	*gHLEventAdd,*gHLEventRemove;//high level event queue head,tail

/* external network specific globals */

extern	short		gTCPDrvrRefNum;				// driver ref num for MacTCP
extern	char		gOurIPString[256];			// for SMTP gateway "HELO" message
