
enum {

	// correctable errors
	
	kInvalidUsername = 1,			// user name is invalid
	kInvalidPasssword,				// password is invalid
	kMacTCPNotAvailable,			// MacTCP isn't installed
	kInvalidPopServer,				// POP server isn't responding
	kInvalidSMTPServer,				// SMTP server isn't responding
	
	// non-correctable errors
	
	kCantRun,						// required toolbox functionality not present 
	kUndefinedHighLevelEvent,		// high level event not handled
	kPOPError,						// received unspecified error from POP host
	kSMTPError,						// received unspecified error from SMTP host
	kUnexpectedAOCECondition,		// toolbox handed us something we weren't expecting
	kUnexpectedDataCondition,		// message data from external system was in unexpected form
	
	// other indexes just used to get STR#s
	
	kMacTCPError,
	kAOCEError,
	kToolboxError
};

#define	kFirstCorrectableError		1
#define	kLastCorrectableError		kInvalidSMTPServer
#define	kFirstNonCorrectableError	kCantRun
#define	kLastNonCorrectableError	kUnexpectedDataCondition
