/*

  ####################################################################
  Internet PMSAM Sample Address Template
  1.0b1 version
  
  Steve Falkenburg
  MacDTS 2/11/93
  AppleLink DEVSUPPORT for questions (if you're a supported seed site)  
  ####################################################################
  
  this file contains the PMSAM specific information for the address template
  you should only have to modify this file and not InternetDET.r to get
  things working for your PMSAM address template
  
  to build:

  Rez -i "{CIncludes}" "GenericAddress.r" -append -o InternetAddress
  SetFile -t 'detf' InternetAddress

*/


#ifndef __TYPES__
#include "Types.r"
#endif

#ifndef __OCE.R__
#include "OCE.r"
#endif

#ifndef __OCE__
#include "OCE.h"
#endif

#ifndef __OCETEMPLATES__
#include "OCETemplates.h"
#endif


// ### names used in templates ################################################################
//
// note: to insure no collisions in DET name space, please pre-pend
//       any template names with your 4 character creator, which
//       should be registered through MacDTS (AppleLink: DEVSUPPORT).

#define kSignature				'Inet'						// address type
#define kAspectTemplateName		"Inet_AddressAspect"		// aspect name
#define	kInfoPageTemplateName	"Inet_AddressInfoPage"		// info page name

// names which could be displayed

#define	kAspectKind				"Internet address"			// aspect kind
#define	kNewMenuName			"Internet address"			// address list item title
#define	kPopUpTitle				"Internet"					// pop-up menu title


// ### default aspect new value corresponding to dett from other file #######################


resource 'detb' (kAddressAspect+kDETAspectNewValue, purgeable) {
	kSignature,
	kSignature,
	"Internet Directory",									// directory name
	kSignature,
	"untitled Internet Address",							// name of user (in sublist)
	"\360User",												// type of record
	"address@host"											// extension value (our address)
};


// ### our (snazzy) icons ###################################################################

resource 'icl8' (kAddressAspect+kDETAspectMainBitmap, purgeable) {
	$"0000 0000 00FF F9FF F9FF F9FF F9FF F6F5"            /* ................ */
	$"F6FF 56C0 C000 0000 0000 0000 0000 0000"            /* ..V........... */
	$"0000 0000 0000 F933 3333 3333 33F9 F8F8"            /* .......333333... */
	$"FF01 FFC0 2BC0 C000 0000 0000 0000 0000"            /* ...+......... */
	$"0000 0000 0000 FFF9 3333 3333 33FF C0FF"            /* ........33333.. */
	$"0101 01FF C0C0 2424 F500 0000 0000 0000"            /* ....$$........ */
	$"0000 0000 00F6 F850 FFF9 FFF9 FFF9 FF01"            /* .......P........ */
	$"0101 0101 FFC0 4F50 4FF6 0000 0000 0000"            /* .....OPO....... */
	$"0000 0000 F67B A67B A682 7BFF FFFF 0101"            /* .....{{{..... */
	$"0101 0101 01FF C04F 5750 0000 0000 0000"            /* ......OWP...... */
	$"0000 0000 7B7C 827B 82F6 C0C0 FF01 0101"            /* ....{|{..... */
	$"0101 0101 0101 FF7B 5750 2D00 0000 0000"            /* .......{WP-..... */
	$"0000 0050 7B7B 7B7C 74C0 C0FF 0101 0101"            /* ...P{{{|t..... */
	$"0101 0101 0101 01FF 7B56 50F6 0000 0000"            /* ........{VP..... */
	$"0000 007B 587C 7B7A C0C0 FF01 0101 0101"            /* ...{X|{z...... */
	$"01FF 0101 0101 0101 FF33 F62B 0000 0000"            /* .........3.+.... */
	$"0000 0057 7C4F C04F C0FF 0101 0101 0101"            /* ...W|OO....... */
	$"FF01 FF01 0101 0101 01FF 332C F600 0000"            /* ..........3,.... */
	$"0000 C056 7BC0 2B4F FF01 0101 0101 01FF"            /* ..V{+O........ */
	$"01FF 01FF 0101 0101 0101 FF2C 2C00 0000"            /* ...........,,... */
	$"0000 C04F FBA6 50C0 C0FF 0101 0101 0101"            /* ..O.P....... */
	$"FF01 FF01 0101 0101 0101 01FF 2C00 0000"            /* ............,... */
	$"0000 C0C0 C04F 7BC0 4FF9 FF01 0101 0101"            /* ..O{O....... */
	$"01FF 01FF 0101 0101 0101 0101 FF00 0000"            /* ................ */
	$"0000 C0C0 C0C0 247A A682 A6FF 0101 0101"            /* ..$z..... */
	$"0101 FF01 FF01 0101 01FF 0101 01FF 0000"            /* ................ */
	$"0000 C0C0 C0C0 C07A A6A6 A6A0 FF01 0101"            /* ..z.... */
	$"0101 01FF 0101 0101 FF16 FF01 0101 FF00"            /* ................ */
	$"0000 C0C0 C025 C07B A6A6 A6A6 A6FF 0101"            /* ..%{... */
	$"0101 0101 0101 01FF 1616 16FF 0101 01FF"            /* ................ */
	$"0000 C0C0 C0C0 C02C A6A6 A6A6 A6A6 FF01"            /* ..,.. */
	$"0101 0101 0101 FF16 1616 FF01 0101 FF00"            /* ................ */
	$"0000 C0C0 C0C0 C024 57A6 A67B 7C7B 7BFF"            /* ..$W{|{{. */
	$"0101 0101 0101 01FF 16FF 0101 01FF 0000"            /* ................ */
	$"0000 00C0 C0C0 C0C0 2B82 A67B 7B57 517B"            /* ...+{{WQ{ */
	$"FF01 0101 0101 0101 FF01 0101 FF00 0000"            /* ................ */
	$"0000 00C0 C0C0 C0C0 C050 5E57 5757 517B"            /* ...P^WWWQ{ */
	$"4FFF 0101 0101 0101 0101 01FF F9FF F9FF"            /* O............... */
	$"0000 0000 C0C0 C0C0 C04F 5757 5757 F94F"            /* ....OWWWW.O */
	$"C0C0 FF01 0101 0101 0101 FFFF F933 33F9"            /* ...........33. */
	$"0000 0000 C0C0 C0C0 C050 7B51 5157 25C0"            /* ....P{QQW% */
	$"C0C0 C0FF 0101 0101 01FF C000 F933 33FF"            /* .........33. */
	$"0000 0000 00C0 C0C0 C050 7B57 574F C0C0"            /* .....P{WWO */
	$"C0C0 C0C0 FF01 0101 FFC0 0000 FF33 33F9"            /* ........33. */
	$"0000 0000 0000 C0C0 C07A 7C50 24C0 C0C0"            /* ......z|P$ */
	$"C0C0 C0C0 C0FF 01FF C000 0000 F933 33FF"            /* .......33. */
	$"0000 0000 0000 00C0 C04F 7BC0 C0C0 C0C0"            /* .......O{ */
	$"C0C0 C0C0 C0C0 FFC0 0000 0000 FF33 33F9"            /* ......33. */
	$"0000 0000 0000 0000 C0C0 4F49 24C0 FFF8"            /* ........OI$.. */
	$"F8FF C0C0 C0C0 C000 0000 0000 00F9 33FF"            /* .........3. */
	$"0000 0000 0000 0000 0000 BBBB BBFF FFFF"            /* ............. */
	$"FFFF FFC0 C000 0000 0000 0000 00FF F9F9"            /* .............. */
	$"0000 0000 0000 0000 0000 0000 00FF F5F5"            /* ................ */
	$"F5F5 FF00 0000 0000 0000 0000 0000 00FF"            /* ................ */
	$"0000 0000 0000 0000 0000 0000 00FF FFFF"            /* ................ */
	$"FFFF FF00 0000 0000 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 0000 0000 0000 0000 FFF8"            /* ................ */
	$"F8FF 0000 0000 0000 0000 0000 0000 0000"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF F8F8"            /* ................ */
	$"F8F8 FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FF"            /* ................ */
	$"FFF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
};

resource 'ICN#' (kAddressAspect+kDETAspectMainBitmap, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"07FF F800 0207 A600 0305 1180 06E6 0B40"            /* .............@ */
		$"0FF4 04C0 0FD8 03E0 1F90 01B0 1F20 40D0"            /* ......... @ */
		$"1D40 A058 3B81 5038 3E40 A018 26E0 5008"            /* .@X;P8>@.&.P. */
		$"23F0 2844 21F8 10A2 25FC 0111 21FE 0222"            /* #.(D!..%...!.." */
		$"21FF 0144 10FF 8088 107F C01F 087F 2039"            /* !..D....... 9 */
		$"087E 1069 047C 08C9 0278 0589 0160 0309"            /* .~.i.|..x..`. */
		$"00F2 4605 003F F807 0004 2001 0007 E000"            /* ..F..?.... ..... */
		$"0002 4000 FFFC 3FFF 0001 8000 FFFF FFFF",            /* ..@...?........ */
		/* [2] */
		$"07FE F800 03FF FE00 03FF FC00 07FF FFC0"            /* ............... */
		$"0FFF FFC0 0FFF FFE0 1FFF FFF0 1FFF FFF0"            /* ............... */
		$"1FFF FFF8 3FFF FFF8 3FFF FFF8 3FFF FFF8"            /* ....?...?...?... */
		$"3FFF FFFC 3FFF FFFE 3FFF FFFF 3FFF FFFE"            /* ?...?...?...?... */
		$"3FFF FFFC 1FFF FFF8 1FFF FFFF 0FFF FFFF"            /* ?............... */
		$"0FFF FFEF 07FF FFCF 03FF FF8F 01FF FF0F"            /* .............. */
		$"00FF FE07 003F F807 0007 E001 0007 E000"            /* .....?.......... */
		$"0003 C000 FFFF FFFF FFFF FFFF FFFF FFFF"            /* ............... */
	}
};

resource 'icl4' (kAddressAspect+kDETAspectMainBitmap, purgeable) {
	$"0000 0FDF DFDF DFC0 CFD7 7000 0000 0000"            /* .......p..... */
	$"0000 00DD DDDD DDCC F0F7 C770 0000 0000"            /* .........p.... */
	$"0000 00FD DDDD DF7F 000F 7700 0000 0000"            /* ..........w..... */
	$"0000 0CCC FDFD FDF0 0000 F7CC CC00 0000"            /* ............. */
	$"0000 CDED EBDF FF00 0000 0F7C DC00 0000"            /* ..........|.... */
	$"0000 DBBD BC77 F000 0000 00FD DCC0 0000"            /* ...w......... */
	$"000C DDDB D77F 0000 0000 000F DDCC 0000"            /* .............. */
	$"000D BBDD 77F0 0000 0F00 0000 FDCC 0000"            /* .».w.......... */
	$"000D BC7C 7F00 0000 F0F0 0000 0FDC C000"            /* .¼|........... */
	$"007D D7CC F000 000F 0F0F 0000 00FC C000"            /* .}........... */
	$"007C EEC7 7F00 0000 F0F0 0000 000F C000"            /* .|............ */
	$"0077 7CD7 CDF0 0000 0F0F 0000 0000 F000"            /* .w|........... */
	$"0077 770D EBEF 0000 00F0 F000 0F00 0F00"            /* .ww............ */
	$"0077 777D EEE8 F000 000F 0000 F2F0 00F0"            /* .ww}............ */
	$"0077 7C7D EEEE EF00 0000 000F 222F 000F"            /* .w|}........"/.. */
	$"0077 777C EEEE EEF0 0000 00F2 22F0 00F0"            /* .ww|........"... */
	$"0077 7770 DEED BDDF 0000 000F 2F00 0F00"            /* .wwp......./... */
	$"0007 7777 CBED DDDD F000 0000 F000 F000"            /* ..ww........... */
	$"0007 7777 7CBD DDDD CF00 0000 000F DFDF"            /* ..ww|......... */
	$"0000 7777 7CDD DDDC 77F0 0000 00FF DDDD"            /* ..ww|...w....... */
	$"0000 7777 7CDD DDC7 777F 0000 0F70 DDDF"            /* ..ww|..w....p.. */
	$"0000 0777 7CDD DC77 7777 F000 F700 FDDD"            /* ...w|..www...... */
	$"0000 0077 7DBC 0777 7777 7F0F 7000 DDDF"            /* ...w}.www..p... */
	$"0000 0007 7CD7 7777 7777 77F7 0000 FDDD"            /* ....|wwwww..... */
	$"0000 0000 77CC 07FC CF77 7770 0000 0DDF"            /* ....w..wwp... */
	$"0000 0000 0077 7FFF FFF7 7000 0000 0FDD"            /* .....w....p..... */
	$"0000 0000 0000 0F00 00F0 0000 0000 000F"            /* ................ */
	$"0000 0000 0000 0FFF FFF0 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 00FC CF00 0000 0000 0000"            /* ............... */
	$"FFFF FFFF FFFF FFCC CCFF FFFF FFFF FFFF"            /* .............. */
	$"CCCC CCCC CCCC CCCF FCCC CCCC CCCC CCCC"            /* . */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
};

resource 'ics#' (kAddressAspect+kDETAspectMainBitmap, purgeable) {
{
		$"F200 4D00 2880 1240 2520 1210 0908 3E24"            /* ..M.(.@% ...>$ */
		$"6308 C99C 9AA2 B2DA 9486 D182 6300 3E00",           /* c.ɜ.тc.>. */
		$"F200 7F00 3F80 1FC0 3FE0 1FF0 0FF8 3FFC"            /* ....?.?.....?. */
		$"7FF8 FFFC FFFE FFDE FF86 FF82 7F00 3E00"            /* ............>. */
}
};

resource 'ics8' (kAddressAspect+kDETAspectMainBitmap, purgeable) {
	$"FFFF FFFF 0000 FF00 0000 0000 0000 0000"            /* ................ */
	$"00FF 3333 FFFF 01FF 0000 0000 0000 0000"            /* ..33............ */
	$"0000 FF33 FF01 0101 FF00 0000 0000 0000"            /* ...3............ */
	$"0000 00FF 0101 FF01 01FF 0000 0000 0000"            /* ................ */
	$"0000 FF01 01FF 01FF 0101 FF00 0000 0000"            /* ................ */
	$"0000 00FF 0101 FF01 0101 01FF 0000 0000"            /* ................ */
	$"0000 0000 FF01 01FF 0101 0101 FF00 0000"            /* ................ */
	$"0000 FFFF FFFF FF01 0101 FF01 01FF 0000"            /* ................ */
	$"00FF FFC0 C0C0 FFFF 0101 0101 FF00 0000"            /* ............. */
	$"FFFF C0C0 E3C0 C0FF FF01 01FF FFFF 0000"            /* ............ */
	$"FFC0 C0E3 E3C0 E3C0 FF01 FF33 3333 FF00"            /* .......333.. */
	$"FFC0 E3E3 C0C0 E3C0 FFFF 00FF FF33 FF00"            /* .........3.. */
	$"FFC0 C0E3 C0E3 C0C0 FF00 0000 00FF FF00"            /* ........... */
	$"FFFF C0E3 C0C0 C0FF FF00 0000 0000 FF00"            /* ............ */
	$"00FF FFC0 C0C0 FFFF 0000 0000 0000 0000"            /* ............. */
	$"0000 FFFF FFFF FF00 0000 0000 0000 0000"            /* ................ */
};

resource 'ics4' (kAddressAspect+kDETAspectMainBitmap, purgeable) {
	$"FFFF 00F0 0000 0000 0FDD FF0F 0000 0000"            /* ................ */
	$"00FD F000 F000 0000 000F 00F0 0F00 0000"            /* ................ */
	$"00F0 0F0F 00F0 0000 000F 00F0 000F 0000"            /* ................ */
	$"0000 F00F 0000 F000 00FF FFF0 00F0 0F00"            /* ................ */
	$"0FF7 77FF 0000 F000 FF77 877F F00F FF00"            /* ..w......w..... */
	$"F778 8787 F0FD DDF0 F788 7787 FF0F FDF0"            /* .x.....w.... */
	$"F778 7877 F000 0FF0 FF78 777F F000 00F0"            /* .xxw.....xw..... */
	$"0FF7 77FF 0000 0000 00FF FFF0 0000 0000"            /* ..w............. */
};

resource 'SICN' (kAddressAspect+kDETAspectMainBitmap, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"F200 4D00 2880 1240 2520 1210 0908 3E24"            /* ..M.(.@% ...>$ */
		$"6308 C99C 9AA2 B2DA 9486 D182 6300 3E00",           /* c.ɜ.тc.>. */
		/* [2] */
		$"F200 7F00 3F80 1FC0 3FE0 1FF0 0FF8 3FFC"            /* ....?.?.....?. */
		$"7FF8 FFFC FFFE FFDE FF86 FF82 7F00 3E00"            /* ............>. */
	}
};


