/*-------------------------------------------------------------------------------------
 *
 * AddressOMini AOCE Sample
 *
 * Steve Falkenburg - MacDTS
 *
 * 1991-1993 Apple Computer
 *
 -------------------------------------------------------------------------------------*/
/*
 * trapavailable.c -- check to see if a trap is available
 *
 * change history:
 *
 * SJF		2/16/93		1.0b1		beta seed
 *
 */

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __TRAPS__
#include <Traps.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __GESTALTEQU__
#include <GestaltEqu.h>
#endif

#include "trapavailable.h"

short NumToolboxTraps(void);
TrapType GetTrapType(short theTrap);
	
short NumToolboxTraps(void)
{
	if (NGetTrapAddress(_InitGraf, ToolTrap) == NGetTrapAddress(0xAA6E,ToolTrap))
		return 0x0200;
	else
		return 0x0400;
}

TrapType GetTrapType(short theTrap)
{
	if ((theTrap & 0x0800) > 0)
		return ToolTrap;
	else
		return OSTrap;
}

Boolean	TrapAvailable(short theTrap)
{
	TrapType tType;
	Boolean isAvail;
	
	tType = GetTrapType(theTrap);
	if (tType == ToolTrap)
		{
			theTrap &= 0x07FF;
			if (theTrap >= NumToolboxTraps())
				theTrap = _Unimplemented;
		}
	
	isAvail = NGetTrapAddress(theTrap, tType) != NGetTrapAddress(_Unimplemented, ToolTrap);
	return isAvail;
}