/*
 * AddressOMaticTest.r
 * Copyright  1992-93 Apple Computer Inc. All Rights Reserved.
 */
#include "Types.r"
#include "SysTypes.r"
#define REZ 
#include "AddressOMaticTest.h"
#include "AddressOMaticPrivate.h"

resource 'STR#' (STRN_AOMLabels, "AddressOMatic Labels", purgeable) {
	{
		"Personal Catalog",
		"Catalog Browser",
		"Find Address",
		"Done",
		"To",
		"Open",
		"Save",
		"Find",
		"Stop",
		"CC",
		"Bcc",
		"Find",
		"Search",
#ifdef ENABLE_TYPEIN
		"Type-in Addressing",
		"Address",
		"Catalog"
#endif
	}
};

resource 'STR#' (STRN_BrowsePanelHelpStrings, "Browser Help", purgeable) {
	{
		/* 1: list of addresses */
		"Lists the items available. To add an address from this list,"
		" select it and click the To or CC button."
		" Click option/BCC for blind copy."
		" Click option/Save to save in your personal catalog.",
		/* 2: popup */
		"To see the contents of another catalog, folder, or disk,"
		" select an item from this pop-up menu."
	}
};

resource 'STR#' (STRN_PDPanelHelpStrings, "Personal Catalog Help", purgeable) {
	{
		/* 1: list of addresses */
		"Lists the addresses in your preferred personal catalog."
		" To add an address from this list,"
		" select it and click the To or CC button."
		" Click option/BCC for blind copy.",
		/* 2: popup -- can't happen */
		""
	}
};

resource 'STR#' (STRN_FindPanelHelpStrings, "Find Panel Help", purgeable) {
	{
		/* 1: addresses type-in */
		"Type the address you wish to find.",
		/* 2:Search menu */
		"To change locations for the search, use this popup-menu.",
		/* 3: Result */
		"Lists the items found. To add a found address, select it and"
		" click the To or CC button. You must stop the search"
		" before you can add an address."
	}
};

resource 'MBAR' (MBAR_MenuBar, "Menu Bar") {
	{
		MENU_Apple,
		MENU_File,
		MENU_Edit
	}
};

resource 'MENU' (MENU_Apple, "Apple Menu") {
	MENU_Apple,
	textMenuProc,
	0x7FFFFFFC,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		" 1993 Apple Computer Inc.", noIcon, noKey, noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (MENU_File, "File Menu") {
	MENU_File,
	textMenuProc,
	0x180,
	enabled,
	"File",
	{	/* array: 6 elements */
		/* [1] */
		"New AddressOMatic Window", noIcon, "N", noMark, plain,
		/* [2] */
		"Close Window", noIcon, "W", noMark, plain,
		/* [3] */
		"-", noIcon, noKey, noMark, plain,
		/* [4] */
		"Set User Identity", noIcon, noKey, noMark, plain,
		/* [5] */
		"-", noIcon, noKey, noMark, plain,
		/* [6] */
		"Quit", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (MENU_Edit, "Edit Menu") {
	MENU_Edit,
	textMenuProc,
	0x0,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Undo", noIcon, "Z", noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain,
		/* [3] */
		"Cut", noIcon, "X", noMark, plain,
		/* [4] */
		"Copy", noIcon, "C", noMark, plain,
		/* [5] */
		"Paste", noIcon, "V", noMark, plain,
		/* [6] */
		"Clear", noIcon, noKey, noMark, plain
	}
};

resource 'DITL' (ALRT_NonFatal, "System Error") {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{84, 265, 104, 334},
		Button {
			enabled,
			"Continue"
		},
		/* [2] */
		{83, 185, 103, 243},
		Button {
			enabled,
			"Exit"
		},
		/* [3] */
		{10, 20, 42, 52},
		UserItem {
			disabled
		},
		/* [4] */
		{7, 74, 71, 331},
		StaticText {
			disabled,
			"System Error ^0 ^1 ^2 ^3"
		}
	}
};

resource 'DITL' (ALRT_Fatal, "Fatal System Error") {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{84, 265, 104, 334},
		Button {
			enabled,
			"Exit"
		},
		/* [2] */
		{7, 74, 71, 331},
		StaticText {
			disabled,
			"Fatal System Error ^0 ^1 ^2 ^3"
		},
		/* [3] */
		{10, 20, 42, 52},
		UserItem {
			disabled
		}
	}
};

resource 'DITL' (ALRT_Continue, "Continue Error") {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{84, 255, 104, 335},
		Button {
			enabled,
			"Continue"
		},
		/* [2] */
		{7, 74, 71, 331},
		StaticText {
			disabled,
			"System Error ^0 ^1 ^2 ^3"
		},
		/* [3] */
		{10, 20, 42, 52},
		UserItem {
			disabled
		}
	}
};

resource 'dctb' (ALRT_NonFatal, "System Error", purgeable) {
	{	/* array ColorSpec: 0 elements */
	}
};

resource 'dctb' (ALRT_Fatal, "Fatal System Error", purgeable) {
	{	/* array ColorSpec: 0 elements */
	}
};

resource 'dctb' (ALRT_Continue, "Continue Error", purgeable) {
	{	/* array ColorSpec: 0 elements */
	}
};

resource 'ALRT' (ALRT_Fatal, "Fatal Error Alert") {
	{89, 84, 204, 430},
	ALRT_Fatal,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'ALRT' (ALRT_NonFatal, "System Error Alert") {
	{89, 84, 205, 427},
	ALRT_NonFatal,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'ALRT' (ALRT_Continue, "Continue Alert") {
	{89, 84, 204, 430},
	ALRT_Continue,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'vers' (1) {
	0x1,
	0x0,
	release,
	0x0,
	verUS,
	"1.0",
	"1.0  1993 Apple Computer Inc. All Right"
	"s Reserved"
};

resource 'vers' (2) {
	0x1,
	0x0,
	release,
	0x0,
	verUS,
	"1.0",
	"For AOCE 1.0"
};

resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	393216,
	393216
};

