/*-------------------------------------------------------------------------------------
 *
 * Simple Sample AOCE Application Framework
 *
 * 1991-1993 Apple Computer
 *
 -------------------------------------------------------------------------------------*/
/*
 * globals.c -- repository for global variables
 *
 * change history:
 *
 * SJF		04/21/93		1.0b2		update to b2
 * SJF		03/01/93		1.0b1		added digital signatures
 * SJF		02/09/93		1.0b1		update to b1
 * SJF		10/13/92		1.0d4		update to a11
 * SJF		09/09/92		1.0d3		update to a9
 * SJF		05/07/92		1.0d2		update to a6
 * SJF		11/06/91		1.0d1		initial coding
 *
 */

#include "const.h"
#include "mytypes.h"

/* configuration flags */

Boolean	gHasWaitNextEvent;		// true if we have waitnextevent available
Boolean	gHasAOCE;				// set if the AOCE toolbox is available

/* action flags */

Boolean	gDone;					// application should terminate when set
Boolean	gInBackground;			// true if application is in the background
Boolean	gMenusDirty;			// true if the menu bar needs re-drawing

/* global values */

short 	gCurrentShape;			// shape to draw with
Cursor	gPencilCursor;			// pencil cursor for drawing
Cursor	gWatchCursor;			// watch cursor for waiting
RgnHandle gCursorRgn;			// cursor change region for WaitNextEvent
long	gNextWindowToMake;		// next window #

Boolean	gCanUndo;				// true if we can undo
Boolean	gHasUndo;				// true if we just did an undo
UndoData gUndoCommand;			// undo command data

Boolean	gShowSigners;			// true if we want to show signers

MyPreferences gPreferences;		// preferences for app