#ifndef __WINDOWS__
#include <Windows.h>
#endif

#ifndef __FILES__
#include <Files.h>
#endif

#ifndef __PRINTING__
#include <Printing.h>
#endif

typedef short WindowKind;

typedef struct WInfo WInfo,*WInfoPtr,**WInfoHndl;
typedef void *(*MsgProc)(WindowPtr window,WInfoPtr info,void *data);

struct WInfo {

	WindowPtr window;
	
	long	refCount;	// to uniquely identify the windows
	
	FSSpec	fileSpec;
	short	topIndent;
	short	leftIndent;
	
	void	*data;
	
	MsgProc	m_idle;
	MsgProc	m_fixCursor;
	MsgProc	m_activate;
	MsgProc	m_deactivate;
	MsgProc	m_update;
	MsgProc	m_key;
	MsgProc	m_resize;
	MsgProc	m_click;
	MsgProc	m_destroy;
	MsgProc	m_undo;
	MsgProc	m_cut;
	MsgProc	m_copy;
	MsgProc	m_paste;
	MsgProc	m_clear;
	MsgProc	m_print;
	MsgProc	m_pageSetup;
	MsgProc	m_save;
	MsgProc	m_load;
	MsgProc	m_event;
	MsgProc m_ctrlHit;
	MsgProc m_selectAll;
	MsgProc m_group;
	MsgProc m_unGroup;
	
	THPrint	printRecord;
	Boolean	saved;
	Boolean changed;
	short	fRefNum;
	short	resRefNum;
	
	void	*otherData[8];
	Boolean	otherFlags[8];
};


typedef struct ShapeList ShapeList, *ShapeListPtr;
typedef struct DigSigList DigSigList, *DigSigListPtr;

struct ShapeList {

	// things to sign
	
	short shapeType;
	Point anchor;
	Point destination;
	
	// things to not sign
	
	Boolean isSigned;
	Boolean selected;
	short signatureID;	
	ShapeListPtr next;
	ShapeListPtr subList;
	DigSigListPtr digSig;
};

#define	kShapeSignLength	(sizeof(short)+sizeof(Point)+sizeof(Point))

struct DigSigList {
	ShapeListPtr	shape;
	short			signatureID;
	Boolean			inTemp;
	Boolean			shouldDelete;
	DigSigListPtr	next;
};



struct ControlHitMessage {
	short part;
	ControlHandle control;
	EventRecord *ev;
};

typedef struct ControlHitMessage ControlHitMessage;


struct UndoData {
	WindowPtr window;
	long windowRefCount;
	ShapeList theShape;
};

typedef struct UndoData UndoData, *UndoDataPtr;


struct MyPreferences {
	short			version;
	SMPCloseOptions closeOptions;
	SMPSendOptions	sendOptions;
	SMPSendFormat	sendFormat;
	Boolean			closeOnSend;
	Boolean			closeOptionsDialog;
	Boolean			expandOnCreate;
	Boolean			expandOnOpen;
};

typedef struct MyPreferences MyPreferences, *MyPreferencesPtr;
