/*-------------------------------------------------------------------------------------
 *
 * Simple Sample AOCE Application Framework
 *
 * 1991-1993 Apple Computer
 *
 -------------------------------------------------------------------------------------*/
/*
 * trapavailable.c -- checks to see if a trap is implemented
 *
 * change history:
 *
 * SJF		04/21/93		1.0b2		update to b2
 * SJF		03/01/93		1.0b1		added digital signatures
 * SJF		02/09/93		1.0b1		update to b1
 * SJF		10/13/92		1.0d4		update to a11
 * SJF		09/09/92		1.0d3		update to a9
 * SJF		05/07/92		1.0d2		update to a6
 * SJF		11/06/91		1.0d1		initial coding
 *
 */

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __TRAPS__
#include <Traps.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __GESTALTEQU__
#include <GestaltEqu.h>
#endif

#include "trapavailable.h"

short NumToolboxTraps(void);
TrapType GetTrapType(short theTrap);
	
short NumToolboxTraps(void)
{
	if (NGetTrapAddress(_InitGraf, ToolTrap) == NGetTrapAddress(0xAA6E,ToolTrap))
		return 0x0200;
	else
		return 0x0400;
}

TrapType GetTrapType(short theTrap)
{
	if ((theTrap & 0x0800) > 0)
		return ToolTrap;
	else
		return OSTrap;
}

Boolean	TrapAvailable(short theTrap)
{
	TrapType tType;
	Boolean isAvail;
	
	tType = GetTrapType(theTrap);
	if (tType == ToolTrap)
		{
			theTrap &= 0x07FF;
			if (theTrap >= NumToolboxTraps())
				theTrap = _Unimplemented;
		}
	
	isAvail = NGetTrapAddress(theTrap, tType) != NGetTrapAddress(_Unimplemented, ToolTrap);
	return isAvail;
}